<script setup lang="ts">
import { reactive } from 'vue'
import { useManagerStore } from '@/stores/manager';
import axios from 'axios';
import { useCreatedCustomerStore } from '@/stores/customer.craetion';
import router from '@/router';

const managerState = useManagerStore();
const createdCustomerStore = useCreatedCustomerStore();
const form = reactive({
    "name": null,
    "fax": null,
    "telephone": null,
    "website": null,
    "postalCode": null,
    "address": null,
    "industry": null,
    "type": null,
    "bankName": null,
    "branchName": null,
    "accountNumber": null,
    "paymentTerm": null,
    "accountHolder": null,
    "depositType": null,
    "comment": null,
    "closingDate": null,
    "headcount": null,
    "annualRevenue": null,
    "creatorId": managerState.currentCustomerManagerId,
    "modifierId": managerState.currentCustomerManagerId
})

const onSubmit = async () => {
    try {
        const response = await axios.post('http://localhost:8080/api/v1/customers', form, {
            headers: {
                'accept': '*/*',
                'Content-Type': 'application/json',
            }, withCredentials: true
        });
        createdCustomerStore.setCustomerId(response.data)
    } catch (error) {
        console.error('Error while submitting the form:', error);
    }
}

function cancel() {
    router.push("/customer/portal")
}

</script>

<template>
    <div>
        <!-- Top -->
        <div class="top-text-align-on-each-side">
            <span>取引先</span>
            <span>
                <el-icon color="#409EFC">
                    <QuestionFilled />
                </el-icon>ヘルプ</span>
        </div>
        <div class="center-button-group">
            <el-button type="primary" plain size="small" @click="onSubmit" class="button-group-auto-l-margin">保存</el-button>
            <el-button type="primary" plain size="small" @click="onSubmit">保存して新しく作成</el-button>
            <el-button type="primary" plain size="small" @click="cancel"
                class="button-group-auto-l-margin">キャンセル</el-button>
            <span class="red-must-filled-item">＊必須項目</span>
        </div>

        <!-- Form#取引先情報 -->
        <div class="customer-creation-component">
            <span class="component-title-text">取引先情報</span>
        </div>
        <div class="customer-component-wrapper">
            <el-form :model="form" label-width="auto" size="small" :inline="true" label-position="left">
                <span style="font-size: 12px;">取引先所有者: {{ managerState.currentCustomerManagerName }}</span>
                <br />
                <el-form-item label="＊取引先名">
                    <el-input v-model="form.name" />
                </el-form-item>
                <el-form-item label="FAX">
                    <el-input v-model="form.fax" />
                </el-form-item>
                <br />
                <el-form-item label="電話番号">
                    <el-input v-model="form.telephone" />
                </el-form-item>
                <el-form-item label="Webサイト">
                    <el-input v-model="form.website" />
                </el-form-item>
            </el-form>
        </div>

        <!-- Form#詳細情報 -->
        <div class="customer-creation-component">
            <span class="component-title-text">詳細情報</span>
        </div>
        <div class="customer-component-wrapper">
            <el-form :model="form" label-width="auto" size="small" :inline="true" label-position="left">
                <br />
                <el-form-item label="郵便番号">
                    <el-input v-model="form.postalCode" />
                </el-form-item>
                <el-form-item label="住所">
                    <el-input v-model="form.address" />
                </el-form-item>
                <br />
                <el-form-item label="得意分野">
                    <el-select v-model="form.industry" class="el-select-width" placeholder="分野を選んでください">
                        <el-option value="金融系（銀行）" />
                        <el-option value="金融系（証券）" />
                        <el-option value="金融系（生損保）" />
                        <el-option value="金融系（その他）" />
                        <el-option value="流通" />
                        <el-option value="製造" />
                        <el-option value="組込み・制御" />
                        <el-option value="官公庁" />
                        <el-option value="その他" />
                    </el-select>
                </el-form-item>
                <el-form-item label="従業員数">
                    <el-input v-model="form.headcount" />
                </el-form-item>
                <br />
                <el-form-item label="取引先の種別">
                    <el-select v-model="form.type" class="el-select-width" placeholder="種別を選んでください">
                        <el-option value="アナリスト" />
                        <el-option value="競合" />
                        <el-option value="顧客" />
                        <el-option value="インテグレーター（統合）" />
                        <el-option value="投資家" />
                        <el-option value="パートナー" />
                        <el-option value="報道機関" />
                        <el-option value="見込顧客" />
                        <el-option value="代理店" />
                        <el-option value="その他" />
                    </el-select>
                </el-form-item>
                <el-form-item label="年間売上">
                    <el-input v-model="form.annualRevenue" />
                </el-form-item>
                <br />
                <el-form-item label="銀行名">
                    <el-input v-model="form.bankName" />
                </el-form-item>
                <el-form-item label="支店名">
                    <el-input v-model="form.branchName" />
                </el-form-item>
                <br />
                <el-form-item label="口座番号">
                    <el-input v-model="form.accountNumber" />
                </el-form-item>
                <el-form-item label="締め日">
                    <el-date-picker style="width: 100px;" v-model="form.closingDate" type="date" placeholder="日付" />
                </el-form-item>
                <el-form-item label="支払サイト">
                    <el-select v-model="form.paymentTerm" class="el-select-width-small" placeholder="支払サイト">
                        <el-option value="45" />
                        <el-option value="60" />
                        <el-option value="90" />
                    </el-select>
                </el-form-item>
                <br />
                <el-form-item label="名義人">
                    <el-input v-model="form.accountHolder" />
                </el-form-item>
                <el-form-item label="預金種別">
                    <el-select v-model="form.depositType" placeholder="種別を選んでください">
                        <el-option value="普通預金" />
                        <el-option value="当座預金" />
                        <el-option value="貯蓄預金" />
                        <el-option value="その他" />
                    </el-select>
                </el-form-item>
            </el-form>

            <!-- Form#所有者会社追加情報（暫定） -->
            <div class="customer-creation-component">
                <span class="component-title-text">所有者会社追加情報（暫定）</span>
            </div>
            <div class="customer-component-wrapper">
                <el-form :model="form" label-width="auto" size="small" :inline="true" label-position="left">
                    <br />
                    <el-form-item label="銀行名">
                        <el-input v-model="form.bankName" />
                    </el-form-item>
                    <el-form-item label="支店名">
                        <el-input disabled v-model="form.branchName" />
                    </el-form-item>
                    <br />
                    <el-form-item label="口座番号">
                        <el-input disabled v-model="form.accountNumber" />
                    </el-form-item>
                    <el-form-item label="名義人">
                        <el-input disabled v-model="form.accountHolder" />
                    </el-form-item>
                    <br />
                    <el-form-item label="預金種別">
                        <el-select disabled placeholder=" " v-model="form.depositType">
                            <el-option value="預金種別：" />
                            <el-option value="普通預金" />
                            <el-option value="当座預金" />
                            <el-option value="貯蓄預金" />
                            <el-option value="その他" />
                        </el-select>
                    </el-form-item>
                    <br />
                    <span class="el-form-item__label">備考</span>
                    <el-input v-model="form.comment" :rows="4" type="textarea" />
                </el-form>
            </div>

            <!-- repeated as doc -->
            <br>
            <div class="center-button-group">
                <el-button type="primary" plain size="small" class="button-group-auto-l-margin">保存</el-button>
                <el-button type="primary" plain size="small">保存して新しく作成</el-button>
                <el-button type="primary" plain size="small" class="button-group-auto-l-margin">キャンセル</el-button>
                <span class="red-must-filled-item"></span>
            </div>
        </div>
    </div>
</template>

<style>
.top-text-align-on-each-side {
    display: flex;
    justify-content: space-between;
}

.center-button-group {
    display: flex;
    justify-content: center;
    margin-top: 12px;
    margin-bottom: 30px;
}

.button-group-auto-l-margin {
    margin-left: auto;
}

.red-must-filled-item {
    color: red;
    margin-left: auto;
}

.customer-creation-component {
    background-color: hsl(213, 46%, 91%) !important;
    border: 2px solid hsl(213, 42%, 38%) !important;
    width: 100% !important;
    font-weight: bold;
}

.customer-component-wrapper {
    background-color: hsl(0, 0%, 95%) !important;
    width: 100% !important;
    border-top: none !important;
}

.component-title-text {
    font-weight: bold !important;
    margin-left: 8px;
}

.el-select-width {
    width: 160px;
}

.el-select-width-small {
    width: 100px;
}
</style>
